lexer grammar Jet;
options {
  language=Java;

}
@members {

	enum Quote { NONE, SINGLE, DOUBLE};
	Quote quote = Quote.NONE;
    boolean directive = false;
    
	void trim(int front, int back) {
		text = getText();
	    setText( text.substring( front, text.length() - back ) );
	}
}
@header {
package com.tikal.codegen.jet.parser;
}

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 71
fragment NAMECHAR : LETTER | DIGIT | '.' | '-' | '_' | ':' ;
// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 72
fragment DIGIT : '0'..'9' ;
// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 73
fragment LETTER : 'a'..'z' | 'A'..'Z' ;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 75
WHITESPACE
	: { directive }?=> (' '|'\r'|'\t'|'\u000C'|'\n') { $channel = HIDDEN; }
	;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 79
JET_COMMENT
	: '<%--' ( options { greedy = false; } : . )* '--%>' { trim( 4, 4 );}
	;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 83
JET_EXPRESSION
	: '<%=' ( options { greedy = false; } : . )* '%>' { trim( 3, 2 );}
	;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 87
JET_SCRIPTLET
	: '<%' ~( '@' | '=' | '-' ) ( options { greedy = false; } : . )* '%>' { trim( 2, 2 ); }
	;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 91
JET_DIRECTIVE_OPEN
	: { !directive }?=> '<%@' {directive = true;}
	;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 95
JET_DIRECTIVE_CLOSE
	: { directive }?=> '%>' {directive = false;}
	;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 99
ID
    : { directive }?=> ( LETTER | '_' | ':' ) ( NAMECHAR )*
    ;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 103
ATTR_EQ
	: { directive }?=> '=' 
	;
	
// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 107
ATTR_VALUE
	: { directive }?=> (
	'\'' ( options { greedy = false; } : . )* '\'' 
	| '\"' ( options { greedy = false; } : . )* '\"'
	) { trim( 1, 1 );}
	;

// $ANTLR src "/Users/mark/projects/tikal/maven-jet-plugin/src/main/antlr/com/tikal/codegen/jet/parser/Jet.g3" 114
TEXT options {greedy = false;}
	: { !directive }?=> .
	;
	